import { DraftState } from "./types";
import { AppState } from "../types";
import { Module } from "vuex";

const namespaced = true;

import actions from "./actions";
import mutations from "./mutations";
import getters from "./getters";

export const state: DraftState = {
  cards: [],
  picks: [],
  pod: [],
  packCount: 0,
  currentPack: 0
};

export const draft: Module<DraftState, AppState> = {
  namespaced,
  state,
  actions,
  mutations,
  getters
};

export default draft;
